searchNodes=[{"ref":"EctoTablestore.Repo.html","title":"EctoTablestore.Repo","type":"behaviour","doc":"Defines a repository for Tablestore. A repository maps to an underlying data store, controlled by Ecto.Adapters.Tablestore adapter. When used, the repository expects the :otp_app option, and uses Ecto.Adapters.Tablestore by default. The :otp_app should point to an OTP application that has repository configuration. For example, the repository: defmodule EctoTablestore.MyRepo do use EctoTablestore.Repo, otp_app: :my_otp_app end Configure ex_aliyun_ots as usual: config :ex_aliyun_ots, MyInstance, name: &quot;MY_INSTANCE_NAME&quot;, endpoint: &quot;MY_INSTANCE_ENDPOINT&quot;, access_key_id: &quot;MY_OTS_ACCESS_KEY&quot;, access_key_secret: &quot;MY_OTS_ACCESS_KEY_SECRET&quot; config :ex_aliyun_ots, instances: [MyInstance] Add the following configuration to associate MyRepo with the previous configuration of ex_aliyun_ots: config :my_otp_app, EctoTablestore.MyRepo, instance: MyInstance"},{"ref":"EctoTablestore.Repo.html#c:__adapter__/0","title":"EctoTablestore.Repo.__adapter__/0","type":"callback","doc":"Returns the adapter tied to the repository."},{"ref":"EctoTablestore.Repo.html#c:batch_get/1","title":"EctoTablestore.Repo.batch_get/1","type":"callback","doc":"Batch get several rows of data from one or more tables, this batch request put multiple get_row in one request from client&#39;s perspective. After execute each operation in servers, return results independently and independently consumes capacity units. Example batch_get([ {SchemaA, [[ids: ids1], [ids: ids2]]}, [%SchemaB{keys: keys1}, %SchemaB{keys: keys2}] ]) batch_get([ {[%SchemaB{keys: keys1}, %SchemaB{keys: keys2}], filter: filter(&quot;attr_field&quot; == 1), columns_to_get: [&quot;attr_field&quot;, &quot;attr_field2&quot;]} ])"},{"ref":"EctoTablestore.Repo.html#c:batch_write/1","title":"EctoTablestore.Repo.batch_write/1","type":"callback","doc":"Batch write several rows of data from one or more tables, this batch request put multiple put_row/delete_row/update_row in one request from client&#39;s perspective. After execute each operation in servers, return results independently and independently consumes capacity units. Example The options are similar as put_row / delete_row / update_row, but expect transaction_id option. batch_write([ delete: [ schema_entity_a, schema_entity_b ], put: [ {%SchemaB{}, condition: condition(:ignore)}, {%SchemaA{}, condition: condition(:expect_not_exist)} ], update: [ {changeset_schema_a, return_type: :pk}, {changeset_schema_b} ] ])"},{"ref":"EctoTablestore.Repo.html#c:delete/2","title":"EctoTablestore.Repo.delete/2","type":"callback","doc":"Please see Ecto.Repo.delete/2 for details."},{"ref":"EctoTablestore.Repo.html#c:get/3","title":"EctoTablestore.Repo.get/3","type":"callback","doc":"Fetch a single struct from tablestore where the whole primary key(s) match the given ids. Options columns_to_get, string list, return the specified attribute columns, if not specify this option field, will try to return all attribute columns together. start_column, string, used as a starting column for Wide Column read, the return result contains this as starter. end_column, string, used as a ending column for Wide Column read, the return result DON NOT contain this column. filter, used as a filter by condition, support &quot;&gt;&quot;, &quot;&lt;&quot;, &quot;&gt;=&quot;, &quot;&lt;=&quot;, &quot;==&quot;, &quot;and&quot;, &quot;or&quot; and &quot;()&quot; expressions. The ignore_if_missing can be used for the non-existed attribute column, for example: An attribute column does not exist meanwhile set it as true, will ignore this match condition in the return result; An existed attribute column DOES NOT suit for this usecase, the match condition will always affect the return result, if match condition does not satisfy, they won&#39;t be return in result. filter: filter((&quot;name[ignore_if_missing: true]&quot; == var_name and &quot;age&quot; &gt; 1) or (&quot;class&quot; == &quot;1&quot;)) transaction_id, read under local transaction in a partition key."},{"ref":"EctoTablestore.Repo.html#c:get_range/4","title":"EctoTablestore.Repo.get_range/4","type":"callback","doc":"Get multiple structs by range from one table, rely on the conjunction of the partition key and other primary key(s). Options direction, set it as :forward to make the order of the query result in ascending by primary key(s), set it as :backward to make the order of the query result in descending by primary key(s). columns_to_get, string list, return the specified attribute columns, if not specify this field all attribute columns will be return. start_column, string, used as a starting column for Wide Column read, the return result contains this as starter. end_column, string, used as a ending column for Wide Column read, the return result DON NOT contain this column. filter, used as a filter by condition, support &quot;&gt;&quot;, &quot;&lt;&quot;, &quot;&gt;=&quot;, &quot;&lt;=&quot;, &quot;==&quot;, &quot;and&quot;, &quot;or&quot; and &quot;()&quot; expressions. The ignore_if_missing can be used for the non-existed attribute column, for example: An attribute column does not exist meanwhile set it as true, will ignore this match condition in the return result; An existed attribute column DOES NOT suit for this usecase, the match condition will always affect the return result, if match condition does not satisfy, they won&#39;t be return in result. filter: filter((&quot;name[ignore_if_missing: true]&quot; == var_name and &quot;age&quot; &gt; 1) or (&quot;class&quot; == &quot;1&quot;)) transaction_id, read under local transaction in a partition key."},{"ref":"EctoTablestore.Repo.html#c:insert/2","title":"EctoTablestore.Repo.insert/2","type":"callback","doc":"Please see Ecto.Repo.insert/2 for details."},{"ref":"EctoTablestore.Repo.html#c:one/2","title":"EctoTablestore.Repo.one/2","type":"callback","doc":"Similar to get/3, please ensure schema entity has been filled with the whole primary key(s). NOTICE: If there are some attribute column(s) are provided in entity, these fields will be combined within multiple :== filtering expressions; If there are some attribute column(s) are provided and meanwhile set filter option, they will be merged into a composite filter. Options Please refer get/3."},{"ref":"EctoTablestore.Repo.html#c:search/3","title":"EctoTablestore.Repo.search/3","type":"callback","doc":"Provide search index features for the following scenarios: MatchAllQuery MatchQuery MatchPhraseQuery TermQuery TermsQuery PrefixQuery RangeQuery WildcardQuery BoolQuery NestedQuery ExistsQuery Currently, not supported search index features which are depended by ex_aliyun_ots GeoBoundingBoxQuery GeoDistanceQuery GeoPolygonQuery"},{"ref":"EctoTablestore.Repo.html#c:start_link/1","title":"EctoTablestore.Repo.start_link/1","type":"callback","doc":"Please see Ecto.Repo.start_link/2 for details."},{"ref":"EctoTablestore.Repo.html#c:update/2","title":"EctoTablestore.Repo.update/2","type":"callback","doc":"Please see Ecto.Repo.update/2 for details."},{"ref":"EctoTablestore.Repo.html#t:search_result/0","title":"EctoTablestore.Repo.search_result/0","type":"type","doc":""},{"ref":"EctoTablestore.Schema.html","title":"EctoTablestore.Schema","type":"module","doc":"Defines a schema for Tablestore. Since the atomic increment may need to return the increased value, EctoTablestore.Schema module underlying uses Ecto.Schema, and automatically append all :integer field type with read_after_writes: true option by default. An Ecto schema is used to map any data source into an Elixir struct. The definition of the schema is possible through the API: tablestore_schema/2. tablestore_schema/2 is typically used to map data from a persisted source, usually a Tablestore table, into Elixir structs and vice-versa. For this reason, the first argument of tablestore_schema/2 is the source(table) name. Structs defined with tablestore_schema/2 also contain a __meta__ field with metadata holding the status of struct, for example, if it has bee built, loaded or deleted. Since Tablestore is a NoSQL database service, embedded_schema/1 is not supported so far. About timestamps Since Tablestore&#39;s column does not support DateTime type, use UTC timestamp (:integer type) as timestamps() macro for the generated inserted_at and updated_at fields by default. About primary_key primary_key supports :id (integer()) and :binary_id (binary()) @primary_key default to false the first defined primary key is partition key up to 4 primary key(s) (Tablestore product required) up to 1 primary key with autogenerate: true option (Tablestore product required) Example defmodule User do use EctoTablestore.Schema tablestore_schema &quot;users&quot; do field :outer_id, :binary_id, primary_key: true field :internal_id, :id, primary_key: true, autogenerate: true field :name, :string field :desc end end By default, if not explicitly set field type will process it as :string type."},{"ref":"EctoTablestore.Schema.html#tablestore_schema/2","title":"EctoTablestore.Schema.tablestore_schema/2","type":"macro","doc":""},{"ref":"readme.html","title":"Alibaba Tablestore adapter for Ecto","type":"extras","doc":"Alibaba Tablestore adapter for Ecto Ecto 3.x adapter for Alibaba Tablestore, this is based on ex_aliyun_ots build to implement Ecto.Adapter and Ecto.Adapter.Schema behaviours. Supported features: Compatible Ecto.Repo API. Support schema&#39;s timestamps() macro, make inserted_at and updated_at as an integer UTC timestamps. Support :map | {:map, _} | :array | {:array, _} field type, use Jason to encode the field value into :string when save, use Jason to simply decode the field value into :map | :array when read, the :keys option of Jason&#39;s decode always use :string. Automatically converts the returned original row results into corresponding schema(s). Automatically generate the provided attribute-column field(s) of schema entity into the filter expression option of GetRow (see EctoTablestore.Repo.one/2) and BatchGet (see EctoTablestore.Repo.batch_get/1). Automatically generate the provided attribute-column field(s) of schema entity into the condition expression option of BatchWrite. Automatically map changeset&#39;s attribute-column field(s) into UpdateRow operation when call EctoTablestore.Repo.update/2: Use atomic increment via {:increment, integer()} in changeset, and return the increased value in the corrsponding field(s) by default; Set any attribute(s) of schema changeset as nil will :delete_all that attribute-column field(s); Set existed attribute(s) in schema changeset will :put to save. Implement Tablestore row related functions in EctoTablestore.Repo module, please see document for details: PutRow GetRow UpdateRow DeleteRow GetRange BatchGetRow BatchWriteRow Search"},{"ref":"readme.html#usage","title":"Alibaba Tablestore adapter for Ecto - Usage","type":"extras","doc":"1, Configure My instance(s) information of Alibaba Tablestore product. use Mix.Config # config for `ex_aliyun_ots` config :ex_aliyun_ots, MyInstance, name: &quot;MY_INSTANCE_NAME&quot;, endpoint: &quot;MY_INSTANCE_ENDPOINT&quot;, access_key_id: &quot;MY_OTS_ACCESS_KEY&quot;, access_key_secret: &quot;MY_OTS_ACCESS_KEY_SECRET&quot; config :ex_aliyun_ots, instances: [MyInstance] # config for `ecto_tablestore` config :my_otp_app, EctoTablestore.MyRepo, instance: MyInstance 2, Create the EctoTablestore.MyRepo module mentioned earlier in the configuration, use EctoTablestore.Repo and set required otp_app option with your OTP application&#39;s name. defmodule EctoTablestore.MyRepo do use EctoTablestore.Repo, otp_app: :my_otp_app end 3, Each repository in Ecto defines a start_link/0 function that needs to be invoked before using the repository. In general, this function is not called directly, but used as part of your application supervision tree. Add EctoTablestore.MyRepo into your application start callback that defines and start your supervisor. You just need to edit start/2 function to start the repo as a supervisor on your application&#39;s supervisor: def start(_type, _args) do children = [ {EctoTablestore.MyRepo, []} ] opts = [strategy: :one_for_one, name: MyApp.Supervisor] Supervisor.start_link(children, opts) end 4, After finish the above preparation, we can use MyRepo to operate data store."},{"ref":"readme.html#references","title":"Alibaba Tablestore adapter for Ecto - References","type":"extras","doc":"Alibaba Tablestore product official references: English document 中文文档"},{"ref":"readme.html#license","title":"Alibaba Tablestore adapter for Ecto - License","type":"extras","doc":"MIT"}]